<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: sys_admin.php,v 1.2 2006/10/06 12:06:09 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2006 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a dictionary. Add, Browse, Edit, Remove, Update.
 */
/**
 * HTML-form for dictionary
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ] // todo: bolean
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see textcodetoform(), getFormHeight()
 */
function gw_getFormSys($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global $a, $sys, $id, $tid, $topic_mode, $gw_this, $ar_theme;
	global $oFunc, $oL;

	$topic_mode = 'form';
	$strForm = '';
	$trClass = 't';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '25%';
	$trDisabled = 'disabled';
	$oForm = new gwForms();

	$oForm->Set('action', $GLOBALS['sys']['page_admin']);
	$oForm->Set('submitok', $oL->m('3_save'));
	$oForm->Set('submitcancel', $oL->m('3_cancel'));
	$oForm->Set('formbgcolor', $ar_theme['color_2']);
	$oForm->Set('formbordercolor', $ar_theme['color_4']);
	$oForm->Set('formbordercolorL', $ar_theme['color_1']);
	$oForm->Set('align_buttons', $GLOBALS['sys']['css_align_right']);
	$oForm->Set('charset', $sys['internal_encoding']);

	$oForm->arLtr = array('arPost[y_email]',
						 'arPost[locale_name]', 'arPost[visualtheme]','arPost[path_log]',
						 'arPost[page_limit]', 'arPost[time_new]', 'arPost[time_upd]',
						 'arPost[int_max_char_defn]',
						 );
	## ----------------------------------------------------
	##
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while (is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = '';
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span><br/>'; }
	}
	##
	## ----------------------------------------------------
	$oForm->setTag('select', 'class',  'input50');
	unset($gw_this['ar_themes_select']['gw_admin']);

	$strForm .= getFormTitleNav($oL->m('1137'), '');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('site_name') . ':' .  $arReqMsg["site_name"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['site_name'] . $oForm->field("input", "arPost[site_name]", textcodetoform($vars['site_name']), 255) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('site_desc') . ':' .  $arReqMsg["site_desc"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['site_desc'] . $oForm->field("input", "arPost[site_desc]", textcodetoform($vars['site_desc']), 255) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('contact_name') . ':' .  $arReqMsg["y_name"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['y_name'] . $oForm->field("input", "arPost[y_name]", textcodetoform($vars['y_name']), 127) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('contact_email') . ':' .  $arReqMsg["y_email"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['y_email'] . $oForm->field("input", "arPost[y_email]", textcodetoform($vars['y_email']), 127) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('keywords') . ':' .  $arReqMsg["keywords"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['keywords'] . $oForm->field("textarea", "arPost[keywords]", textcodetoform($vars['keywords']), $oFunc->getFormHeight($vars['keywords'])) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('default_lang') . ':' .  $arReqMsg['locale_name'] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['locale_name'] . $oForm->field("select", "arPost[locale_name]", $vars['locale_name'], 0, $oL->getLanguages()) . '</td>'.
				'</tr>';
	$ar_timezones = array(
		'-12' => 'GMT -12',
		'-11' => 'GMT -11',
		'-10' => 'GMT -10',
		'-9' => 'GMT -9',
		'-8' => 'GMT -8',
		'-7' => 'GMT -7',
		'-6' => 'GMT -6',
		'-5' => 'GMT -5',
		'-4' => 'GMT -4',
		'-3.5' => 'GMT -3:30',
		'-3' => 'GMT -3',
		'-2' => 'GMT -2',
		'-1' => 'GMT -1',
		'0' => 'GMT Greenwich Mean Time',
		'1' => 'GMT +1',
		'2' => 'GMT +2',
		'3' => 'GMT +3',
		'4' => 'GMT +4',
		'5' => 'GMT +5',
		'5.75' => 'GMT +5:45',
		'6' => 'GMT +6',
		'6.5' => 'GMT +6:30',
		'7' => 'GMT +7',
		'8' => 'GMT +8',
		'9' => 'GMT +9',
		'9.5' => 'GMT +9:30',
		'10' => 'GMT +10',
		'11' => 'GMT +11',
		'12' => 'GMT +12',
		'13' => 'GMT +13',
	);
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1102') . ':' .  $arReqMsg['gmt_offset'] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['gmt_offset'] . $oForm->field('select', 'arPost[gmt_offset]', $vars['gmt_offset'], 0, $ar_timezones) . '</td>'.
				'</tr>';

	$oForm->setTag('input', 'class', '');
	$oForm->setTag('input', 'size', '4');
	$oForm->setTag('input', 'maxlength', '4');
	$oForm->setTag('input', 'dir', $sys['css_align_numbers'] );

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['prbblty_tasks'] . $oForm->field('input', 'arPost[prbblty_tasks]', $vars['prbblty_tasks']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('prbblty_tasks') . $arReqMsg['prbblty_tasks'] . '</td>'.
				'</tr>';
	$strForm .= '</tbody></table>';

	$strForm .= getFormTitleNav($oL->m('1136'), '');

	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('visual_theme') . ':' .  $arReqMsg['visualtheme'] . '</td>'.
				'<td class="'.$v_class_2.'">' . $oForm->field("select", "arPost[visualtheme]", $vars['visualtheme'], 0, $gw_this['ar_themes_select']) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_list_numbers]', $vars['is_list_numbers']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_numbers_">' . $oL->m('1064') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_list_images]', $vars['is_list_images']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_images_">' . $oL->m('1065') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_show_topic_descr]', $vars['is_show_topic_descr']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_show_topic_descr_">' . $oL->m('1154') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_list_announce]', $vars['is_list_announce']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_announce_">' . $oL->m('1066') . '</label></td>'.
				'</tr>';

	$oForm->setTag('input', 'class', '');
	$oForm->setTag('input', 'size', '11');
	$oForm->setTag('input', 'maxlength', '22');
	$oForm->setTag('input', 'dir', $oL->languagelist('1') );

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['txt_sep_breadcrump'] . $oForm->field('input', 'arPost[txt_sep_breadcrump]', textcodetoform($vars['txt_sep_breadcrump'])) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1098') . $arReqMsg["txt_sep_breadcrump"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['txt_sep_htmltitle'] . $oForm->field('input', 'arPost[txt_sep_htmltitle]', textcodetoform($vars['txt_sep_htmltitle'])) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1097') . $arReqMsg["txt_sep_breadcrump"] . '</td>'.
				'</tr>';

	$oForm->setTag('input', 'size', '4');
	$oForm->setTag('input', 'maxlength', '4');
	$oForm->setTag('input', 'dir', $sys['css_align_numbers'] );

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['page_limit'] . $oForm->field('input', "arPost[page_limit]", $vars['page_limit']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('page_limit') . $arReqMsg["page_limit"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_dict_updated'] . $oForm->field('input', "arPost[max_dict_updated]", $vars['max_dict_updated']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1062') .  $arReqMsg["max_dict_updated"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_dict_top'] . $oForm->field('input', "arPost[max_dict_top]", $vars['max_dict_top']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1063') . $arReqMsg["max_dict_top"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['time_new'] . $oForm->field('input', "arPost[time_new]", $vars['time_new']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('time_new') . $arReqMsg["time_new"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['time_upd'] . $oForm->field('input', "arPost[time_upd]", $vars['time_upd']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('time_upd') . $arReqMsg["time_upd"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['int_max_char_defn'] . $oForm->field('input', "arPost[int_max_char_defn]", $vars['int_max_char_defn']) .  '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1133') . $arReqMsg["int_max_char_defn"] . '</td>'.
				'</tr>';

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_use_xhtml]', $vars['is_use_xhtml']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_use_xhtml_">' . $oL->m('1197') . '</label></td>'.
				'</tr>';

	$strForm .= '</tbody></table>';

	$strForm .= getFormTitleNav($oL->m('1116'));
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['avatar_max_x'] . $oForm->field('input', 'arPost[avatar_max_x]', $vars['avatar_max_x']) .  '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1130') . $arReqMsg["avatar_max_x"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['avatar_max_y'] . $oForm->field('input', 'arPost[avatar_max_y]', $vars['avatar_max_y']) .  '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1131') . $arReqMsg['avatar_max_y'] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['avatar_max_kb'] . $oForm->field('input', 'arPost[avatar_max_kb]', $vars['avatar_max_kb']) .  '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1132') . $arReqMsg['avatar_max_kb'] . '</td>'.
				'</tr>';
	$strForm .= '</tbody></table>';

#	$oForm->setTag('input', 'class', 'input');
#	$oForm->setTag('input', 'size', '20');
#	$oForm->setTag('input', 'dir', '');

	$strForm .= getFormTitleNav($oL->m('1056'));
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_log_search]', $vars['is_log_search']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_log_search_">' . $oL->m('1101') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_days_searchlog'] . $oForm->field('input', 'arPost[max_days_searchlog]', $vars['max_days_searchlog']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1129') .  $arReqMsg['max_days_searchlog'] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_days_searchcache'] . $oForm->field('input', 'arPost[max_days_searchcache]', $vars['max_days_searchcache']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1128') .  $arReqMsg['max_days_searchcache'] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['page_srch_limit'] . $oForm->field('input', "arPost[page_srch_limit]", $vars['page_srch_limit']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1096') . $arReqMsg["page_srch_limit"] . '</td>'.
				'</tr>';
	$strForm .= '</tbody></table>';


	$strForm .= getFormTitleNav($oL->m('1135'));
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_log_ref]', $vars['is_log_ref']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_log_ref_">' . $oL->m('1099') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oForm->field('checkbox', 'arPost[is_log_mail]', $vars['is_log_mail']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_log_mail_">' . $oL->m('1100') . '</label></td>'.
				'</tr>';

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('path_log') . ':' .  '</td>'.
				'<td class="disabled" style="text-align:left">' . textcodetoform($sys['path_logs']). '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('path_cache') . ':' .  '</td>'.
				'<td class="disabled" style="text-align:left">' . textcodetoform($sys['path_cache_sql']). '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1068') . ':' .  '</td>'.
				'<td class="disabled" style="text-align:left">' . textcodetoform($sys['path_export']). '</td>'.
				'</tr>';

	$strForm .= '</tbody></table>';

	$strForm .= $oForm->field("hidden", GW_SID, $gw_this['vars'][GW_SID]);
	$strForm .= $oForm->field("hidden", GW_ACTION, GW_A_CONFIG);
	$strForm .= $oForm->field("hidden", GW_TARGET, GW_T_SYSTEM);


	return $oForm->Output($strForm);
}
// --------------------------------------------------------
$arReq = array(
	'path_tpl', 'path_log', 'path_cache',
	'site_name', 'site_desc', 'y_email', 'y_name', 'locale_name', 'visualtheme',
	'page_limit', 'time_new', 'time_upd', 'int_max_char_defn', 'srch_len',
	'max_dict_updated', 'max_dict_top', 'page_srch_limit','prbblty_tasks',
	'max_days_searchlog', 'max_days_searchcache',
	'avatar_max_x', 'avatar_max_y', 'avatar_max_kb'
);
// --------------------------------------------------------
// Check permission
if ($oSess->have_perm('perm_admin'))
{
// --------------------------------------------------------
// action switcher
switch (${GW_ACTION})
{
case GW_A_CONFIG:
## --------------------------------------------------------
##
	if ($post == '') // not saved
	{
		if (!isset($tid))
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_admin']);
		}
		// set default values
		$arBroken   = array();
		$strR .= gw_getFormSys($sys, 0, $arBroken, $arReq);
	}
	else // parse posted values
	{
		$arBroken = validatePostWalk($arPost, $arReq);

		/* Fix on/off options */
		$arIsV = array('is_list_numbers','is_list_images','is_list_announce',
			'is_log_search', 'is_log_ref', 'is_log_mail', 'is_show_topic_descr',
			'is_use_xhtml'
		);
		for (; list($k, $v) = each($arIsV);)
		{
			$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
		}
		if (sizeof($arBroken) == 0)
		{
			$isPostError = 0;
		}
		else
		{
			$strR .= gw_getFormSys($arPost, 1, $arBroken, $arReq);
		}
		if (!$isPostError) // final update
		{
			$sys['isDebugQ'] = 0;
			$arPost['cache_zlib'] = isset($arPost['cache_zlib']) ? 1 : 0;
			$arPost['page_limit'] = preg_replace("/[^0-9]/", '', $arPost['page_limit']);
			$arPost['time_new'] = preg_replace("/[^0-9]/", '', $arPost['time_new']);
			$arPost['time_upd'] = preg_replace("/[^0-9]/", '', $arPost['time_upd']);
			$arPost['int_max_char_defn'] = preg_replace("/[^0-9]/", '', $arPost['int_max_char_defn']);
			/* */
			for (reset($arPost); list($k, $v) = each($arPost);)
			{
				$q = array();
				$q['settings_key'] = $k;
				$q['settings_val'] = $v;
				$queryA[] = gw_sql_replace($q, TBL_SETTINGS);
#				$queryA[] = gw_sql_replace($q, TBL_SETTINGS, 'settings_key = "' . gw_text_sql($k) .'"');
			}
#			prn_r( $queryA );
			$strR .= gw_tmp_clear();
			$strR .= postQuery($queryA, '', $sys['isDebugQ']);
		}
	}
##
## --------------------------------------------------------
break;
default:
break;
} // end of switch
}
/* end of file */
?>