<?php
$sys['class_session'] = 'q_session';
class q_session extends gw_session
{
	/* Autoexec */
	function q_session()
	{
		global $sys, $gw_this, $oFunc, $oHtml;
		$this->time_now =& $sys['time_now_gmt_unix'];
		$this->prefix = 'GW1_';
		$this->user_db_class = 'gwtkDb';
		$this->user_db_table = TBL_USERS;
		$this->sess_db_table = TBL_SESS;
		$this->sess_name = GW_SID;
		$this->set_method = 'var';
		$this->url_admin = $sys['server_proto'] . $sys['server_host'] . $sys['page_admin'];
		$this->url_login = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'];
		$this->remote_ip = $oFunc->ip2int(REMOTE_IP);
		$this->remote_ua = REMOTE_UA;
		$this->id_sess_get = $gw_this['vars'][GW_SID];
		$oHtml->id_sess = $gw_this['vars'][GW_SID];
		$this->user_db_plain = array('perm_level','int_terms','user_name','user_email','date_login','date_reg');
		/* Session will be expired in `n' seconds (3600 = 1 hour) */
		$this->int_timeout = 10800;
	}
	/* Predefined user permissions */
	function get_arPermBits()
	{
		return array(
			'perm_admin'      => '11111111111111',
			'perm_a_manager'  => '10010010011110',
			'perm_p_manager'  => '11111111111110',
			'perm_p_assistant'=> '10010011101010',
			'perm_guest'      => '10010010000000'
		);
	}
	/* Predefined user levels */
	function get_arPermLevels()
	{
		return array(
			'perm_admin'      => 16,
			'perm_a_manager'  => 8,
			'perm_p_manager'  => 4,
			'perm_p_assistant'=> 2,
			'perm_guest'      => 1
		);
	}
	/* Access map per action */
	function get_arAccessNames()
	{
		return array(
			'topic_view',
			'topic_add',
			'topic_edit_other',
			'dict_view',
			'dict_add',
			'dict_edit',
			'term_view',
			'term_add',
			'term_edit_other',
			'user_add',
			'user_edit',
			'user_edit_other',
			'sys_pm',
			'sys_settings',
		);
	}
	/**
	 * @param   string  $p  permissions
	 * @param   int     $d  dictionary ID
	 */
	function is_allow($p, $d = '')
	{
		$accessnames = $this->get_arAccessNames();
		$ar_dict =& $this->user_get('dictionaries');
		for (; list($k, $v) = each($accessnames);)
		{
			/* selected dictionary */
			if (($p == $v) && ($d != ''))
			{
				/* Admin, author */
				if ((($p == 'dict_edit') || ($p == 'dict_add') || ($p == 'dict_edit') || ($p == 'term_add')) 
					&& ($this->user_get('perm_level') >= 2)
					)
				{
					return ($this->user_get('perm_level') == 16) ? 1 : isset($ar_dict[$d]);
				}
				elseif (($p == 'term_add') && ($this->user_get('perm_level') < 16) && isset($ar_dict[$d]))
				{
					/* Levels below admin should be assigned for editing the dictionary */
					return 1;
				}
				elseif (($p == 'dict_view') && $this->is('dict_view'))
				{
					return 1;
				}
				elseif (($p == 'term_add') && $this->is('term_add'))
				{
					/* All levels */
					return 1;
				}
				elseif (($p == 'term_edit_other') && $this->is('term_edit_other') 
					&& (isset($ar_dict[$d]) || ($this->user_get('perm_level') == 16)))
				{
					/* All levels */
					return 1;
				}
				else
				{
					return 0;
				}
			}
			elseif ($p == $v)
			{
				return substr($this->user_get('perm_bits'), $k, 1);
			}
		}
		return 0;
	}
	/* */
	function get_htmlform($ar_vars, $ar_broken = array(), $ar_req = array())
	{
		global $oL, $oTpl, $oHtml, $oFunc;
		global $sys, $gw_this, $ar_theme;
		
		$oForm = new gwForms();
		$oForm->action = $sys['page_login'];
		$oForm->submitok = $oL->m('3_login');
		$oForm->isButtonCancel = 0;
		$oForm->Set('charset', $sys['internal_encoding']);

		$strForm = '';
		$v_class_1 = 'td1';
		$v_class_2 = 'td2';
		
		/* Mark fields as "REQUIRED" and make error messages */
		$ar_req = array_flip($ar_req);
		while (is_array($ar_vars) && list($k, $v) = each($ar_vars) )
		{
			$ar_req_m[$k] = isset($ar_req[$k]) ? '&#160;<span class="red"><b>*</b></span>' : '';
			$ar_broken_m[$k] = isset($ar_broken[$k]) ? ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span>' : '';
		}
		$oForm->formwidth = '300';
		$oForm->formbgcolor = $ar_theme['color_2'];
		$oForm->formbordercolor = $ar_theme['color_4'];
		
		/* HTML-code */
		if ($gw_this['vars'][GW_ACTION] == 'lostpass')
		{
			/* "Lost password" page */
			$str_formtitle = $oL->m('3_password_lost');
			$oForm->submitok = $oL->m('3_password_send');
			$oForm->strNotes = '<span class="xt">'.
						$oHtml->a( $this->url_login . '?' . GW_TARGET . '=' . GW_T_USER . '&' .  GW_ACTION . '=login',
						'&gt; '.$oL->m('2_login')) .
						'</span>';
			$strForm .= getFormTitleNav($str_formtitle);
			$strForm .= '<table class="gw2TableFieldset" width="100%">';
			$strForm .= '<tbody><tr>'.
						'<td style="width:35%" class="'.$v_class_1.'">' . $oL->m('login') . ':' . $ar_req_m['user_name'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $ar_broken_m['user_name'] . $oForm->field('input', 'arPost[user_name]', textcodetoform($ar_vars['user_name']), 16) . '</td>'.
						'</tr>'; 
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('y_email') . ':' . $ar_req_m['user_email'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $ar_broken_m['user_email'] . $oForm->field('input', 'arPost[user_email]', textcodetoform($ar_vars['user_email']), 64) . '</td>'.
						'</tr>';
			$strForm .= '</tbody></table>';
			$strForm .= $oForm->field('hidden', GW_ACTION, 'lostpass');
		}
		else
		{
			/* "log in" page */
			$oForm->strNotes = '<span class="xt">'.
						$oHtml->a( $this->url_login . '?' . GW_TARGET . '=' . GW_T_USER . '&' .  GW_ACTION . '=lostpass',
						'&gt; '.$oL->m('3_password_lost')) .
						'</span>';
			$str_formtitle = $oL->m('2_login');
			$strForm .= getFormTitleNav($str_formtitle);
			$strForm .= '<table class="gw2TableFieldset" width="100%">';
			$strForm .= '<tbody><tr>'.
					'<td style="width:35%" class="'.$v_class_1.'">' . $oL->m('login') . ':' . $ar_req_m['user_name'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $ar_broken_m['user_name'] . $oForm->field('input', 'arPost[user_name]', textcodetoform($ar_vars['user_name']), 16) . '</td>'.
					'</tr>'; 
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('password') . ':' . $ar_req_m['user_pass'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $ar_broken_m['user_pass'] . $oForm->field('pass', 'arPost[user_pass]', textcodetoform($ar_vars['user_pass']), 16) . '</td>'.
						'</tr>';
			$strForm .= '</tbody></table>';
			$strForm .= $oForm->field('hidden', GW_ACTION, 'login');
		}
		$strForm .= $oForm->field('hidden', GW_SID, $this->id_sess);
		return $oForm->Output($strForm);
	}
}
/* end of file */
?>