<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: func.stat.inc.php,v 1.13 2006/10/06 12:09:34 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2006 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Logging data, file functions, replacement functions.
 */
// --------------------------------------------------------


function gw_set_cookie($n, $value = '', $is_always = 1)
{
	global $sys;
	$expires = mktime() + (60*60*24*7);
	if ($is_always)
	{
		$expires = mktime() + (60*60*24*365);
	}
	$sys['cookie_domain'] = $sys['server_host'];
	$sys['cookie_path'] = ($sys['server_dir'] == '') ? '/' : $sys['server_dir'];
	@setcookie($n, urlencode($value), $expires, $sys['cookie_path'], $sys['cookie_domain']);
}
	

/**
 * Prepare message
 *
 * @param   string  $user_name  User name, not login
 * @param   string  $login      Login, system user name
 * @param   string  $password   Password
 * @param   string  $template   HTML-template
 * @global  $sys
 * @global  $oL
 */
function gwCreateMessage($user_name, $login_url, $login, $password)
{
	global $sys, $oL;
	/* load language files */
	$oL->getCustom('mail', $sys['locale_name'], 'join');
	$mail_sig = $sys['site_name'] . ' - ' . $sys['site_desc'];
	/* templates */
	$arSrc = array('{USERNAME}', '{SITENAME}', '{LOGIN_URL}', '{LOGIN}', '{U_LOGIN}', '{PASSWORD}', '{U_PASSWORD}', '{CONTACT_EMAIL}');
	$arTrg = array($user_name,
				   $sys['site_name'],
				   $login_url, $oL->m('login'),
				   $login,
				   $oL->m('password'),
				   $password,
				   '<a href="mailto:'. $sys['y_email'].'">'.$sys['y_email'].'</a>'
			 );
	$msgBody = str_replace($arSrc, $arTrg, $oL->m('mail_newuser'));
	$msgSubj = str_replace($arSrc, $arTrg, $oL->m('mail_newuser_subj'));
	/* */
	$oTpl = new $sys['class_tpl'];
	$oTpl->init('gw_admin');
	$oTpl->addVal( 'v:language',         $oL->languagelist("0") );
	$oTpl->addVal( 'v:text_direction',   $oL->languagelist("1") );
	$oTpl->addVal( 'v:charset',          $oL->languagelist("2") );
	$oTpl->addVal( 'v:email_signature',  $mail_sig );
	$oTpl->addVal( 'v:message',          $msgBody );
	$oTpl->addVal( 'v:subject',          $msgSubj );
	/* I request you to retain the copyright notice! */
	$oTpl->addVal( 'v:copyright',        'Powered&#160;by <a href="http://glossword.info/">Glossword</a>&#160;' );
	$oTpl->set_tpl(GW_TPL_MAIL);
	$oTpl->parse();
	return $oTpl->output();
}



/**
 * Reads directory
 *
 * @param   string  $strDir path to directory
 * @param   string  $ex     preg_match pattern
 *
 * @return  array   The list of directories
 */
function file_readDirD($strDir, $ex = "(.*)"){
	$ar = array();
	if (is_dir($strDir))
	{
		$h_dir = opendir($strDir);
		while (($f = readdir($h_dir)) !== false)
		{
			if ($f != '.' && $f != '..' && is_dir($strDir . '/' . $f))
			{
				if ( preg_match($ex, $f ) )
				{
					$ar[$f] = $f;
				}
			}
		}
		closedir($h_dir);
	}
	return $ar;
}
/**
 * Reads files
 *
 * @param   string  $strDir path to directory with files
 * @param   string  $ex     preg_match pattern
 *
 * @return  array   The list of directories
 */
function file_readDirF($strDir, $ex = "(.*)"){
	$ar = array();
	if (is_dir($strDir))
	{
		$h_dir = opendir($strDir);
		while (($f = readdir($h_dir)) !== false)
		{
			if ($f != '.' && $f != '..' && is_file($strDir . '/' . $f))
			{
				if ( preg_match($ex, $f) )
				{
					$ar[] = $f;
				}
			}
		}
		closedir($h_dir);
	}
	return $ar;
}



/**
 * Sends mail
 *
 * @param   string  $email   e-mail address.
 * @param   string  $subj    subject.
 * @param   string  $body    message text.
 * @param   int     $isDebug if true, do not send message and display it on screen.
 *
 * @return  boolean True if success.
 * @global  array   $sys System variables
 */
function kMailTo($email, $from, $subj = '', $body = "\n kMailTo()", $isDebug = 0)
{
	global $sys, $oLog, $oFunc;
	$arHeader = array();
	$arHeader[] = 'From: ' . htmlspecialchars($from);
	$arHeader[] = 'Return-Path: <' . htmlspecialchars($from) . '>';
	$arHeader[] = 'X-Mailer: Glossword ' . $sys['version'];
	$arHeader[] = 'X-Priority: 3';
	$arHeader[] = 'MIME-Version: 1.0';
	$arHeader[] = 'Content-type: text/html; charset='.$sys['internal_encoding'];
	$header = implode("\n", $arHeader);
	$isSuccess = 0;
	if ($isDebug)
	{
		$header = str_replace(">", "&gt;", $header);
		$header = str_replace("<", "&lt;", $header);
		print "\n\n<pre>$header\nSubject: $subj</pre>\n$body";
		return $isDebug;
	}
	$subj = 'Glossword notification'; /* can't put UTF-8 characters into subject */
	if (@mail($email, $subj, $body, $header))
	{
		$isSuccess = 1; //
	}
	/* Log mail messages */
	if ($sys['is_log_mail'])
	{
		if (!isset($oLog))
		{
			$oLog = new gw_logwriter($sys['path_logs']);
		}
		$arLogMail = array(
			$sys['time_now_gmt_unix'],
			$oFunc->ip2int(REMOTE_IP),
			$body
		);
		$oFunc->file_put_contents($oLog->get_filename('mail'), $oLog->make_str($arLogMail), 'a');
	}
	return $isSuccess;
}

?>