<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: t.term.inc.php,v 1.20 2006/10/06 12:09:35 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2006 Dmitry N. Shilnikov <dev at glossword dot info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a terms. Add, Edit, Remove.
 */
// --------------------------------------------------------

function gw_getFormDefinition($arParsed, $is_first = 1, $arReq = array())
{
	global $ar_theme, $sys, $id, $gw_this, $tid, $arDictParam, $arFields;
	global $oL, $oDom, $oSess;
	  
	$strForm = ''; // all HTML-code for the form
	$tmp = array(); // all temporary variables for this function
	$tmp['cssTrClass'] = 'xt';
	// ----------------------------------------------------
	// prepare HTML-form settings
	$form = new gw_htmlforms;
	$form->Set('action',          $sys['page_admin'] );
	$form->Set('submitok',        $oL->m('3_save')   );
	$form->Set('submitcancel',    $oL->m('3_cancel') );
	$form->Set('formbgcolor',     $ar_theme['color_2']  );
	$form->Set('formbordercolor', $ar_theme['color_4']  );
	$form->Set('formbordercolorL',$ar_theme['color_1']  );
	$form->Set('align_buttons',   $sys['css_align_right']);
	$form->Set('charset',         $sys['internal_encoding']);

	$arDictParam['is_htmled'] = $oSess->user_get('is_htmled');

	$form->Set('Gsys', $sys ); // system, settings
	$form->Set('Gtmp', $tmp ); // temporary settings for current function
	$form->Set('oL', $oL ); /* Language object */
	$form->Set('objDom', $oDom );
	$form->Set('arDictParam', $arDictParam );
	$form->load_abbr_trns();
	// ----------------------------------------------------
	//
	// ----------------------------------------------------
	$strForm .= $form->field('hidden', GW_TARGET, GW_T_TERM);
	$strForm .= $form->field('hidden', 'id', $id);
	$strForm .= $form->field('hidden', 'tid', $gw_this['vars']['tid']);
	$strForm .= $form->field('hidden', GW_SID, $gw_this['vars'][GW_SID]);
	if ($gw_this['vars'][GW_ACTION] == GW_A_ADD)
	{
		$tmp['intFormHeight'] = 8;
		$strForm .= $form->field('hidden', GW_ACTION, GW_A_ADD);
		$strForm .= getFormTitleNav($oL->m('term'), '');
	}
	else
	{
		$strForm .= $form->field('hidden', 'arPre[date_created]', $arParsed['date_created']);
		$strForm .= $form->field('hidden', GW_ACTION, GW_A_UPDATE);
		$strForm .= getFormTitleNav($oL->m('term') .
				' (<a href="'.$sys['page_index'].'?'.GW_ACTION.'='.GW_T_TERM.'&amp;d='.$id.'&amp;'.GW_TARGET.'='.$tid.'" onclick="window.open(this.href);return false">www</a>)',
				'<input style="width:24px" class="submitdel" title="'. $oL->m('3_remove') . ' ' .
				'" type="submit" value="&#215;" name="arPre[term][remove]['.$id.']" ' .
				'onclick="vbcontrol.style.visibility=\'hidden\'" />');
	}
	// ...
	// Send XML array to $form class
	$form->Set('arEl', $arParsed );

	// prepare form fields
	$strForm .= '
<script type="text/javascript">/*<![CDATA[*/
function switch2edit(id)
{
	el = gw_getElementById("arPre_" + id + "_value_");
	el_d = gw_getElementById("d_" + id);
	el_d.style.display = "none";
	el.style.display = "block";
}
/*]]>*/
</script>';
	$strForm .= '<table class="gw2TableFieldset" width="100%"><tbody>';

	$form->Set('arFields', $arFields );
	// Go for each configured root field.
	for (reset($arFields); list($fK, $fV) = each($arFields);)
	{
		if(isset($fV[4]) && $fV[4]) // select root elements only here
		{
			if ($fV[0] == 'term') // terms always presents
			{
				$strForm .= $form->tag2field($fV[0]);
			}
			else
			{
				// other tags are switchable, parsed inside $form class
				if ($arDictParam['is_'.$fV[0]])
				{
					$strForm .= $form->tag2field($fV[0]);
				}
			}
		} // end of root elements
	} // end of per-field process
	$strForm .= '</tbody></table>';

	/* 1.6.3 */
	$strForm .= getFormTitleNav($oL->m('options'));
	$tmp['after_post'] = $oSess->user_get('after_post_term');
	if (!$tmp['after_post'])
	{
		$tmp['after_post'] = GW_AFTER_TERM_ADD;
	}
	$tmp['ar_after_posting'] = array(
		GW_AFTER_TERM_ADD => $oL->m('3_add_term'),
		GW_AFTER_DICT_UPDATE => $oL->m('after_post_1'),
		GW_AFTER_SRCH_BACK => $oL->m('after_post_3')
	);
	/* */
	$form->unsetTag('select');
	$form->setTag('select', 'class',  'input50');
	$strForm .= '<table class="gw2TableFieldset" width="100%"><tbody>';
	$strForm .= '<tr><td style="width:15%"></td><td></td></tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $oL->m('after_post') . '</td>'.
				'<td class="td2">' . $form->field('select', 'arPost[after]', $tmp['after_post'], '', $tmp['ar_after_posting']). '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $form->field('checkbox', 'arPost[after_is_save]', $arParsed['after_is_save']) . '</td>'.
				'<td class="td2"><label for="arPost_after_is_save_">' . $oL->m('after_post_is_save_term') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $form->field('checkbox', 'arPost[is_parse_url]', $arParsed['is_parse_url']) . '</td>'.
				'<td class="td2"><label for="arPost_is_parse_url_">' . $oL->m('1118') . '</label></td>'.
				'</tr>';
	$strForm .= '</tbody></table>';
	return $form->Output($strForm);
}
// --------------------------------------------------------
// Check permission
if ($oSess->is_allow('term_edit_other', $id))
{
// --------------------------------------------------------
// action switcher
switch ($gw_this['vars'][GW_ACTION])
{
case GW_A_ADD:
## --------------------------------------------------------
## Add a term
	if ($post == '') // not saved
	{
		$is_first = 1;
		if (!isset($gw_this['vars']['id']))
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_admin']);
		}
		$arBroken = array();
		// default values
		$arParsed['term'][0]['value'] = '';
		$arParsed['term'][0]['attributes']['t1'] = '';
		$arParsed['term'][0]['attributes']['t2'] = '';
		$arParsed['term'][0]['attributes']['is_active'] = 1;
		$arParsed['trsp'][0]['value'] = '';
		$arParsed['abbr'][0][0]['value'] = '';
		$arParsed['abbr'][0][0]['attributes']['lang'] = '';
		$arParsed['defn'][0]['value'] = '';
		$arParsed['after_is_save'] = 1;
		$arParsed['is_parse_url'] = 1;
		/* Restore term settings */
		if ($oSess->user_get('form_term_'.$id))
		{
			$arParsed = $oSess->user_get('form_term_'.$id);
		}
		/* Additional actions */
		if (is_array($arPre))
		{
			$is_first = 0;
			$arParsed = gw_ParsePre($arParsed, $arPre);
		}
		$oDom = new gw_domxml;
		$oDom->setCustomArray($arParsed);
		$strR .= gw_getFormDefinition($arParsed, $is_first, $arReq[$t]);
	}
	else
	{
		// for custom DOM model
		$arPre['term'][0]['tag'] = 'term';
		$arPre['after_is_save'] = isset($arPost['after_is_save']) ? 1 : 0;
		
		$isPostError = 0;
		$queryA = array();

		$oDom = new gw_domxml;
		$oDom->setCustomArray($arPre);

		// check for broken fields
		if ($arPre['term'][0]['value'] == '')
		{
			$is_first = 0;
			$isPostError = 1;
			$strR .= gw_getFormDefinition($arPre, $is_first, $arReq[$t]);
		}
		if (!$isPostError) // final update
		{
#			$id_w = $oDb->MaxId($arDictParam['tablename']);
			$q = array();
			/* Exclude stopwords */
			$arStop = gw_get_stopwords($arDictParam);

			$tmp['cssTrClass'] = 'xt';
			$oRender = new gw_render;

			$oRender->Set('Gtmp', $tmp ); /* to remove */
			$oRender->Set('Gsys', $sys ); /* to remove */
			$oRender->Set('oL', $oL ); /* to remove */
			$oRender->Set('objDom', $oDom );
			$oRender->Set('arDictParam', $arDictParam ); /* to remove */
			$oRender->Set('arEl', $arPre );
			$oRender->Set('arFields', $arFields ); /* to remove */

			/* Create XML-code from array */
			$arPre['parameters']['xml'] = $oRender->array_to_xml($arPre);
			$arPre['parameters']['action'] = GW_A_UPDATE;
			/* */
			$queryA = $q = array();
			$arPre['is_specialchars'] = 1;
			$arPre['is_overwrite'] = 0;
			$arPre['is_parse_url'] = isset($arPost['is_parse_url']) ? 1 : 0;
			/* Automatically parse URLs */
			if ($arPre['is_parse_url'])
			{
				$arPre['parameters']['xml'] = preg_replace("/(^|\s)((http|https|news|ftp|aim|callto):\/\/\w+[^\s\[\\]]+)/ie"  , "gw_regex_url(array('html' => '\\2', 'show' => '\\2', 'st' => '\\1'))", $arPre['parameters']['xml']);
			}
			/* */
# $sys['isDebugQ'] = 1;
			/* Construct queries for the term */
			$ar = gwAddTerm($arPre, $id, $arStop, 1, $arPre['is_specialchars'], $arPre['is_overwrite'], 0);
			/* */
			if (is_array($ar))
			{
				$queryA = array_merge($queryA, $ar);
			}
			else
			{
				$strR .= $ar;
			}
			/* New query: clean search results for edited dictionary */
			$queryA[] = $oSqlQ->getQ('del-srch-by-dict', $d);
			/* Clear dictionary cache */
			$strR .= gw_tmp_clear($id);
			$arPre['after_is_save'] = isset($arPost['after_is_save']) ? 1 : 0;
			/* Add term settings to user settings */
			if ($arPost['after_is_save'])
			{
				/* Save, but clear 'value' keys */
				$oSess->user_set('after_is_save', 1 );
				$oSess->user_set('is_parse_url', $arPre['is_parse_url'] );
				$oSess->user_set('form_term_'. $id, array_clear_key($arPre, 'value') );
			}
			else
			{
				$oSess->user_unset('after_is_save');
				$oSess->user_unset('is_parse_url');
				$oSess->user_unset('form_term_'. $id);
			}
			if (empty($strR))
			{
				/* Redirect to... */
				$str_url = gw_after_redirect_url($arPost['after']);
				$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 0);
			}
		}
	}
##
## --------------------------------------------------------
break;
case GW_A_EDIT:
## --------------------------------------------------------
## Edit selected term

	if ($post == '') // not saved
	{
		// read data from database,
		// see `if(!empty($tid))' in admin.php
		if (isset($arTermParam['term']))
		{
			$arParsed['term'][0]['value'] = $arTermParam['term'];
			$arParsed['term'][0]['attributes']['is_active'] = $arTermParam['is_active'];
			$arParsed['term'][0]['attributes']['t1'] = $arTermParam['term_1'];
			$arParsed['term'][0]['attributes']['t2'] = $arTermParam['term_2'];
			$arParsed['after_is_save'] = $oSess->user_get('after_is_save');
			$arParsed['is_parse_url'] = $oSess->user_get('is_parse_url');
			$arParsed['date_created'] = $arTermParam['date_created'];
			/* Convert XML data into structured array */
			$arParsed = array_merge_clobber($arParsed, gw_Xml2Array($arTermParam['defn']));
			/* */
			$oDom = new gw_domxml;
			$oDom->setCustomArray($arParsed);
			/* */
			$is_first = 1;
			if (is_array($arPre))
			{
				$is_first = 0;
				$arParsed = gw_ParsePre($arParsed, $arPre);
			}
			$strR .= gw_getFormDefinition($arParsed, $is_first, $arReq[$t]);
		}
		else
		{
			/* on error */
			$strR .= $oL->m('reason_13');
		}
	}
	else
	{
		$oDom = new gw_domxml;
		$oDom->setCustomArray($arPre);
		$isPostError = 0;
		$arPre['after_is_save'] = isset($arPost['after_is_save']) ? 1 : 0;
		$arPre['is_parse_url'] = isset($arPost['is_parse_url']) ? 1 : 0;
		/* Check for broken fields */
		if ($arPre['term'][0]['value'] == '')
		{
			$is_first = 0;
			$isPostError = 1;
			$strR .= gw_getFormDefinition($arPre, $is_first, $arReq[$t]);
		}
		if (!$isPostError)
		{
			/* Changes for custom DOM model */
			$arPre['term'][0]['tag'] = 'term';
			$arPre['term'][0]['attributes']['is_active'] = isset($arPre['term'][0]['attributes']['is_active']) ? 1 : 0;
			/* */
			$tmp['cssTrClass'] = 'xt';
			$oRender = new gw_render;
			$oRender->Set('Gtmp', $tmp );
			$oRender->Set('Gsys', $sys ); // system, settings
			$oRender->Set('oL', $oL ); // language
			$oRender->Set('objDom', $oDom );
			$oRender->Set('arDictParam', $arDictParam );
			$oRender->Set('arEl', $arPre );
			$oRender->Set('arFields', $arFields );
			/* */
			$arPre['parameters']['xml'] = $oRender->array_to_xml($arPre);
			$arPre['parameters']['action'] = GW_A_UPDATE;
			/* update table TBL_DICT */
			$queryA = $q = array();
			$arPre['is_specialchars'] = 1;
			$arPre['is_overwrite'] = 1;
			/* */
# $sys['isDebugQ'] = 1;
			/* Exclude stopwords */
			$arStop = gw_get_stopwords($arDictParam);
			/* Automatically parse URLs */
			if ($arPre['is_parse_url'])
			{
				$arPre['parameters']['xml'] = preg_replace("/(^|\s)((http|https|news|ftp|aim|callto):\/\/\w+[^\s\[\\]]+)/ie"  , "gw_regex_url(array('html' => '\\2', 'show' => '\\2', 'st' => '\\1'))", $arPre['parameters']['xml']);
			}
			/* Construct queries for the term */
			$ar = gwAddTerm($arPre, $id, $arStop, 1, $arPre['is_specialchars'], $arPre['is_overwrite'], 0, 1);
			/* */
			if (is_array($ar))
			{
				$queryA = array_merge($queryA, $ar);
			}
			else
			{
				$strR .= $ar;
			}
			/* Term was edited, clean search results for edited dictionary */
			$queryA[] = $oSqlQ->getQ('del-srch-by-dict', $d);
			/* Clear cache */
			$strR .= gw_tmp_clear($id);
			/* Redirect to... */
			$str_url = gw_after_redirect_url($arPost['after']);
			$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 0);
		}
	}
##
## --------------------------------------------------------
break;
case GW_A_REMOVE:
## --------------------------------------------------------
## Remove selected term
	if (!$oSess->is('term_edit_other'))
	{
		$strR .= $oL->m('reason_13');
	}
	else
	{
		if (!isset($arTermParam))
		{
			$ar_terms = array();
			if (isset($gw_this['vars']['arPost']['ar_id']))
			{
				reset($gw_this['vars']['arPost']['ar_id']);
				while (list($k1, $id_term) = each($gw_this['vars']['arPost']['ar_id']))
				{
					$arTermParam = getTermParam($id_term);
					$ar_terms[] = $arTermParam['term'];
				}
			}
			$arTermParam['term'] = implode(', ', $ar_terms);
			$arTermParam['defn'] = '';
		}
		if (!$isConfirm) /* if not confirmed */
		{
			$str_question = '<p class="xr red"><b>' . $oL->m('9_remove') .'</b></p>'
										. '<p class="xt"><span class="gray">' . $oL->m('3_'.$gw_this['vars'][GW_ACTION]) .':</span><br />' . $arTermParam['term']. '</p>'
										. '<p class="xt"><span class="gray">'. $oL->m('defn') . ':</span><br />'
										. $oFunc->mb_substr(strip_tags(str_replace('><', '> <', $arTermParam['defn'])), 0, $sys['int_max_char_defn']). '&#8230;</p>';

			$tmp['after_post'] = $oSess->user_get('after_post_term');
			if (!$tmp['after_post'])
			{
				$tmp['after_post'] = GW_AFTER_SRCH_BACK;
			}
			$tmp['ar_after_posting'] = array(
				GW_AFTER_TERM_ADD => $oL->m('3_add_term'),
				GW_AFTER_DICT_UPDATE => $oL->m('after_post_1'),
				GW_AFTER_SRCH_BACK => $oL->m('after_post_3')
			);
			$form = new gw_htmlforms;
			$form->unsetTag('select');
			$form->setTag('select', 'class',  'input');
			$strForm = '';
			$strForm .= '<table class="gw2TableFieldset" width="100%"><tbody>';
			$strForm .= '<tr><td style="width:25%"></td><td></td></tr>';
			$strForm .= '<tr>'.
						'<td class="td1">' . $oL->m('after_post') . '</td>'.
						'<td class="td2">' . $form->field('select', 'arPost[after]', $tmp['after_post'], '100%', $tmp['ar_after_posting']). '</td>'.
						'</tr>';
			$strForm .= '</tbody></table>';


			$str_question .= $strForm;

			$Confirm = new gwConfirmWindow;
			$Confirm->action = $GLOBALS['sys']['page_admin'];
			$Confirm->submitok = $oL->m('3_remove');
			$Confirm->submitcancel = $oL->m('3_cancel');
			$Confirm->formbgcolor = $ar_theme['color_2'];
			$Confirm->formbordercolor = $ar_theme['color_4'];
			$Confirm->formbordercolorL = $ar_theme['color_1'];
			$Confirm->setQuestion($str_question);
			$Confirm->tAlign = "center";
			$Confirm->formwidth = "400";
			$Confirm->setField("hidden", GW_ACTION, GW_A_REMOVE);
			$Confirm->setField("hidden", GW_TARGET, $gw_this['vars'][GW_TARGET]);
			$Confirm->setField("hidden", "id", $id);
			$Confirm->setField("hidden", "tid", $tid);
			if (isset($gw_this['vars']['arPost']['ar_id']))
			{
				reset($gw_this['vars']['arPost']['ar_id']);
				while (list($k1, $id_term) = each($gw_this['vars']['arPost']['ar_id']))
				{
					$Confirm->setField("hidden", "arPost[ar_id][]",  $id_term);
				}
			}
			$Confirm->setField("hidden", GW_SID, $gw_this['vars'][GW_SID]);
			$strR .= $Confirm->Form();
		}
		else
		{
			/*
			 1) Delete term from dictionary, $DBTABLE
			 2) Delete term from assiged keywords, TBL_WORDMAP
			 3) Delete term from assiged terms to user, TBL_MAP_USER_TERM
			 4) Update dictionary settings, table TBL_DICT
			 5) ? CHECK and OPTIMIZE dictionary, $DBTABLE
			*/
#			$sys['isDebugQ'] = 1;
			$queryA = array();
			
			if (!isset($gw_this['vars']['arPost']['ar_id']))
			{
				$gw_this['vars']['arPost']['ar_id'] = array($gw_this['vars']['tid']);
			}
			reset($gw_this['vars']['arPost']['ar_id']);
			while (list($k1, $id_term) = each($gw_this['vars']['arPost']['ar_id']))
			{
				$queryA[] = 'DELETE FROM ' . $DBTABLE . ' WHERE id = "' . $id_term . '"';
				$queryA[] = 'DELETE FROM ' . TBL_WORDMAP . ' WHERE term_id = "' . $id_term . '"';
				$queryA[] = 'DELETE FROM ' . TBL_MAP_USER_TERM . ' WHERE term_id = "' . $id_term . '" AND dict_id = "' . $id . '"';
			}
			$qDict['date_modified'] = $sys['time_now_gmt_unix'];
			$qDict['int_terms'] = gw_sys_dict_count_terms();
			$qDict['int_bytes'] = gw_sys_dict_count_kb();
			$where = 'id = "' . $id . '"';
			$queryA[] = gw_sql_update($qDict, TBL_DICT, $where);
			/* Clear cache */
			$strR .= gw_tmp_clear($id);
			/* Optimization for previous (not current) modifications */
#			gw_sys_dict_check($DBTABLE);
			/* Redirect to... */
			$str_url = gw_after_redirect_url($arPost['after']);
			$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 0);
		}
	}
##
## --------------------------------------------------------
break;
case GW_A_UPDATE:
## --------------------------------------------------------
## Update a term
	if (isset($t_term))
	{
		$arTermParam['t_term'] = $t_term;
		$isPostError = 1;
		$strR .= getFormDefn($arParsed, $arTermParam, 0, $arBroken, $arReq[$t]);
	}
	else
	{
		/* */
		$queryA = array();
		
		if (isset($gw_this['vars']['arPost']['selected_term_on']))
		{
			/* Publish term */
			$sql = 'UPDATE %s SET is_active = "1" WHERE id IN (%s)';
			$sql = sprintf($sql, $arDictParam['tablename'], implode(',', $gw_this['vars']['arPost']['ar_id']));
			$queryA[] = $sql;
		}
		elseif (isset($gw_this['vars']['arPost']['selected_term_off']))
		{
			/* Unpublish term */
			$sql = 'UPDATE %s SET is_active = "0" WHERE id IN (%s)';
			$sql = sprintf($sql, $arDictParam['tablename'], implode(',', $gw_this['vars']['arPost']['ar_id']));
			$queryA[] = $sql;
		}
		elseif (isset($gw_this['vars']['arPost']['selected_term_move']))
		{
			$arDictParamSource = getDictParam($gw_this['vars']['arPost']['id_source']);
			
			/* Check permission to edit terms for both dictionaries */
			if (!$oSess->is_allow('term_edit_other', $arDictParam['id']) 
			  && !$oSess->is_allow('term_edit_other', $arDictParamSource['id']))
			{
#				$strR .= $oL->m('reason_13');
#				return;
			}
#			$sys['isDebugQ'] = 1;
			/* Move term */
			/*
				1. Add term to Target dictionary
				2. Update gw_wordmap
				3. Update gw_map_user_to_term
				4. Remove term from Source
			*/
			$sql = 'SELECT * FROM %s WHERE id IN (%s)';
			$arSql = $oDb->sqlExec(sprintf($sql, $arDictParamSource['tablename'], implode(',', $gw_this['vars']['arPost']['ar_id'])));
			$id_term = $oDb->MaxId($arDictParam['tablename'], 'id');
			while (list($k1, $arV) = each($arSql))
			{
				$queryA = array();
				$id_term_prev = $arV['id'];
				$arV['id'] = $id_term;
				$queryA[] = gw_sql_insert($arV, $arDictParam['tablename']);
				$q1['term_id'] = $arV['id'];
				$q1['dict_id'] = $arDictParam['id'];
				$queryA[] = gw_sql_update($q1, TBL_WORDMAP, sprintf('term_id = "%d" AND dict_id = "%d"', $id_term_prev, $arDictParamSource['id']));
				$queryA[] = gw_sql_update($q1, TBL_MAP_USER_TERM, sprintf('term_id = "%d" AND dict_id = "%d"', $id_term_prev, $arDictParamSource['id']));
				$queryA[] = $oSqlQ->getQ('del-by-id', $arDictParamSource['tablename'], $id_term_prev);
				$id_term++;
				if ($sys['isDebugQ'])
				{

				}
				else
				{
					/* Post queries */
					for (reset($queryA); list($qk, $qv) = each($queryA);)
					{
						$oDb->sqlExec($qv);
					}
				}
			}
		}
		/* Redirect to... */
		$str_url = gw_after_redirect_url(GW_AFTER_SRCH_BACK);
		$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 0);
	}
##
## --------------------------------------------------------
break;
default:
break;
} // end of switch
// --------------------------------------------------------
// End check permission
}
else
{
	$strR .= $oL->m('reason_13');
}
/* End of file  */
?>