<?php
/*
	Session handler
	 2004-2006 Dmitry N. Shilnikov <dev at glossword dot info>
	http://glossword.info/dev/

	Changes:
		12 feb 2004: changed syntax for comments
	Requires:
	- gwtkDb{}
	- oHtml->paramValue()
	- oSqlQ{}, queries 'get-user', 'sess-purge'
	- gw_text_sql()
	- gwtk_header()
*/
class gw_session
{
	var $ar_user = array();
	var $remote_ip;
	var $remote_ua;
	var $is_use_remote_ip = 0;
	var $is_use_remote_ua = 0;
	var $time_refresh = 2;
	/* Current session number */
	var $id_sess = 0;
	var $name = 'sid';
	/* Session number from URL */
	var $id_sess_get = 0;
	var $is_changed = 0;
	var $time_now;
	var $user_db_class = 'gwtkDb';
	var $user_db_table = 'sh_users';
	var $sess_db_table = 'sh_sessions';
	var $user_db_field = 'user_settings';
	var $user_db_where = 'id_user';
	var $user_db_plain = array();
	/* Login page */
	var $url_login = '';
	/* Page with administrative functions */
	var $url_admin = '';
	/* Garbage collect probability in percent */
	var $gc_probability = 4; 
	/* Purge all session data older than 86400 seconds (24 hours). */
	var $gc_time = 86400;
	/* Session will be expired in `n' seconds (3600 = 1 hour) */
	var $int_timeout = 3600;
	/* */
	var $prefix = 'G_';
	var $url_append_mode = 'get';
	var $str_secret = "\x01";

	/* */
	var $ar_permissions = '';
	var $ar_permissions_user = '';
	/* variable | contant */
	var $set_method = 'constant';
	/* */
	/* Autoexec */
	function gw_session()
	{
		$this->user_db_plain = array('perm_level','user_name','user_email','date_login','date_reg');
	}
	/* */
	function user_init()
	{
#		prn_r( 'user_init()', __LINE__ );
		$this->ar_user = array(
			'ip' => $this->remote_ip,
			'ua' => $this->remote_ua,
			'changed' => '',
			'settings' => array(
				'id_auth' => 1,
				'user_name' => 'Guest',
				'user_email' => '',
				'group' => 5,
				'perm_bits' => '',
				'perm_level' => 1,
			)
		);
#		unset( $this->remote_ip );
#		unset( $this->remote_ua );
	}
	/* */
	function start($id_level = 1)
	{
#prn_r( 'start', __LINE__ );
		$this->user_init();
		$this->auth($id_level);
		$this->gc();
	}
	/* Error handing */
	function error($error_code = 0)
	{
		$msg = '';
		switch ($error_code)
		{
			case 1:
				$msg = 'Session expired in case of inactivity.';
				$msg .= '<br />';
				$msg .= 'Passed: '. intval(($this->time_now - $this->time_changed) / 60) . ' min. Time to idle: ' . intval($this->int_timeout / 60) .' min.';
				
			break;
			case 2:
				$msg = 'Session does not exist.';
			break;
			case 3:
				$msg = 'You have logged out.';
				$this->id_sess = '';
			break;
			default:
				
			break;
		}
		@header('Content-Type: text/html; charset=utf-8');
		print '<html><head>';
		print '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
		print '<meta http-equiv="Refresh" content="'.$this->time_refresh.';url='.$this->url($this->url_login).'" />';
		print '</head><body>';
		print $msg;
		print '<br /><a href="'.$this->url($this->url_login).'">'.$this->url_login.'</a>';
		print '</body></html>';
		$this->user_close();
		exit;
	}
	/**
	 * called from auth()
	 */
	function get_session($id_sess = '')
	{
		global $oSqlQ, $oDb;
		$id_sess = preg_replace("/([^a-zA-Z0-9])/", '', $id_sess);
		if ($id_sess == '')
		{
			/* No session ID defined */
			return;
		}
		$sql = $oSqlQ->getQ('get-session', $id_sess);
		$arSql = $oDb->sqlExec($sql);
		while (list($k, $arV) = each($arSql))
		{
			/* Session expired */
			if (($this->time_now - $arV['changed']) > $this->int_timeout)
			{
				$this->time_changed = $arV['changed'];
				$this->error(1);
			}
			else
			{
				$this->id_sess = $id_sess;
				$this->user_start($arV['id_user']);
			}
		}
		if (!$this->id_sess)
		{
			/* No such session */
			/* Start Guest session */
			/* SQL-table `gw_auth', column 2 */
			$this->ar_user['id_sess'] = $this->make_session_id();
			$this->put_session($this->ar_user['id_sess']);
			$this->user_start(1);
			$this->error(2);
		}
		/* Read session from database */
		/* Get User ID based on session settings */
		/* Authorize User ID */
	}
	/**
	 * called from auth()
	 */
	function put_session()
	{
		global $oSqlQ, $oDb;
		$arSqlV = array();
		$arSqlV['id_sess'] = $this->ar_user['id_sess'];
		$arSqlV['ip'] = $this->ar_user['ip'];
		$arSqlV['ua'] = $this->ar_user['ua'];
		$arSqlV['id_user'] = $this->user_get('id_auth');
		$arSqlV['changed'] = $this->time_now;
		$arSqlV['sess_settings'] = serialize(array());
		for (reset($arSqlV); list($k, $v) = each($arSqlV);)
		{
			$arSqlVN['`'.$k.'`'] = "'".gw_text_sql($v)."'";
			unset($arSqlV[$k]);
		}
		$sql = sprintf('INSERT INTO %s (%s) VALUES (%s)',
					$this->sess_db_table,
					implode(', ', array_keys($arSqlVN)),
					implode(', ', array_values($arSqlVN))
				);
		$oDb->sqlExec($sql);
		$this->id_sess = $this->ar_user['id_sess'];
	}
	/**
	 * called from auth_login()
	 */
	function update_session($vars = array())
	{
		global $oSqlQ, $oDb;
		$arSqlV = array();
		$arSqlV['id_user'] = $this->user_get('id_auth');
		$arSqlV['changed'] = $this->time_now;
		$arSqlV['ip'] = $this->remote_ip;
		$arSqlV['ua'] = $this->remote_ua;
		$arSqlV['sess_settings'] = serialize($vars);
		$sql = gw_sql_update($arSqlV, $this->sess_db_table, sprintf('id_sess = "%s"', $this->id_sess));
		if (!$oDb->sqlExec($sql))
		{
			print $sql;
			exit;
		}
	}
	/* Authorize */
	function auth($id_level = 1)
	{
		if ($this->id_sess_get == '')
		{
			$this->sess_id = $this->sess_id_get = 0;
			/* Create new session */
			$this->ar_user['id_sess'] = $this->make_session_id();
			$this->put_session($this->ar_user['id_sess']);
			/* Open "Log in" page */
			global $gw_this, $sys, $oHtml;
			gwtk_header($this->url($this->url_login . '?' .$oHtml->paramValue($gw_this['vars'], '&', '')), $sys['is_delay_redirect']);
			exit;
		}
		else
		{
			$this->get_session($this->id_sess_get);
		}
		$id_level = $this->ar_user['settings']['perm_level'];
		$arPermLevels = $this->get_arPermLevels();
		$arPermBits = $this->get_arPermBits();
		$arAccessNames = $this->get_arAccessNames();
		$arPermLevels = array_flip($arPermLevels);
		if (!$id_level || !isset($arPermLevels[$id_level])) { $id_level = 1; }
		$this->ar_user['settings']['perm_bits'] = ($this->ar_user['settings']['perm_bits'] == '') ? $arPermBits['perm_guest'] : $this->ar_user['settings']['perm_bits'];
#		isset($arPermBits[$arPermLevels[$id_level]]) ? $arPermBits[$arPermLevels[$id_level]] : $arPermBits['perm_guest'];
		for (; list($k, $v) = each($arAccessNames);)
		{
			if ($this->set_method == 'constant')
			{
				define(strtoupper($this->prefix.$v), substr($this->ar_user['settings']['perm_bits'], $k, 1) );
			}
			else
			{
				$this->ar_permissions[strtoupper($v)] = substr($this->ar_user['settings']['perm_bits'], $k, 1);
			}
		}
		/* Clean not authorized sessions (spider bots, etc.) */
		$this->gc_empty();
	}
	function auth_login($arPost)
	{
		global $oSqlQ, $oDb;
		/* Check login */
		$is_login = 0;
		$ar_newvars = array();
		$sql = $oSqlQ->getQ('cmp-login-pass', gw_addslashes($arPost['user_name']), md5($arPost['user_pass']));
		$arSql = $oDb->sqlExec($sql);
		while (list($k, $arV) = each($arSql))
		{
			/* account is inactive */
			if ($arV['is_active'] == 0)
			{
				$is_login = 2;
				break;
			}
			$is_login = 1;
			$this->user_start($arV['id_auth']);
			$this->user_set('date_login', $this->time_now);
			/* Put $ar_newvars into the session */
			$ar_newvars['perm_bits'] = $arV['perm_bits'];
			$ar_newvars['user_name'] = $arV['user_name'];
			$ar_newvars['login'] = $arV['login'];
		}
		if ($is_login == '1')
		{
			/* Session id is valid */
			$this->id_sess = $this->id_sess_get;
			$this->update_session($ar_newvars);
			$this->user_close();
		}
		return $is_login;
	}
	/* */
	function auth_user($ar_user)
	{
		$id_level = $ar_user['perm_level'];
		$arPermLevels = $this->get_arPermLevels();
		$arPermBits = $this->get_arPermBits();
		$arAccessNames = $this->get_arAccessNames();
		$arPermLevels = array_flip($arPermLevels);
		if (!$id_level || !isset($arPermLevels[$id_level])) { $id_level = 1; }
		for (; list($k, $v) = each($arAccessNames);)
		{
			$this->ar_permissions_user[strtoupper($v)] = substr($ar_user['perm_bits'], $k, 1);
		}
	}
	/* */
	function auth_info($id_user = '', $username = '', $email = '', $password = '')
	{
		global $oDb;
		$arSql = array();
		$sql = '';
		if ($id_user != '')
		{
			/* Select by User ID */
			$sql = sprintf('SELECT a.*, u.is_active
							FROM %s as a, %s as u
							WHERE u.id_user = a.id_auth
							AND u.id_user = "%d"',
							TBL_AUTH, $this->user_db_table, $id_user
					);
		}
		elseif ($username != '')
		{
			/* Select by login */
			$sql = sprintf('SELECT a.id_auth
							FROM %s as a, %s as u
							WHERE u.id_user = a.id_auth
							AND a.login = "%s"',
							TBL_AUTH, $this->user_db_table, $username
					);
		}
		elseif ($email != '')
		{
			/* Select by email */
			$sql = sprintf('SELECT a.id_auth
							FROM %s as a, %s as u
							WHERE u.id_user = a.id_auth
							AND u.user_email = "%s"',
							TBL_AUTH, $this->user_db_table, $email
					);
		}
		elseif ($password != '')
		{
			/* Select by password */
			$sql = sprintf('SELECT a.id_auth
							FROM %s as a, %s as u
							WHERE u.id_user = a.id_auth
							AND STRCMP(a.password, "%s") = 0',
							TBL_AUTH, $this->user_db_table, md5($password)
					);
		}
		if ($sql != '')
		{
			$arSql = $oDb->sqlExec($sql);
		}
		return $arSql;
	}
	/* Check permission */
	function is($perm, $is_target = 0)
	{
		$perm = strtoupper($perm);
		if ($is_target)
		{
			return isset($this->ar_permissions_user[$perm]) ? $this->ar_permissions_user[$perm] : 0;
		}
		if ($this->set_method == 'constant')
		{
			return defined(($this->prefix . $perm)) ? constant($this->prefix . $perm) : 0;
		}
		else
		{
			return isset($this->ar_permissions[$perm]) ? $this->ar_permissions[$perm] : 0;
		}
	}
	/* Predefined user levels */
	function get_arPermLevels()
	{
		return array(
			'perm_admin'     => 16,
			'perm_a_manager' => 8,
			'perm_guest'     => 1
		);
	}
	/* Predefined user permissions */
	function get_arPermBits()
	{
		return array(
			'perm_admin'     => '1111111111111111',
			'perm_p_manager' => '0100111100101111',
			'perm_guest'     => '0100010000000100'
		);
	}
	/* Access map per action */
	function get_arAccessNames()
	{
		return array(
			'g_topic_add',
			'g_topic_view',
			'g_topic_edit',
			'g_topic_edit_other',
			'g_img_add',
			'g_img_view',
			'g_img_edit',
			'g_img_edit_other',
		);
	}
	/* Create permissions bits based on partially defined access names */
	function make_perm_bits($vars, $id_level = 1)
	{
		$arAccessNames = $this->get_arAccessNames();
		$arPermLevels = $this->get_arPermLevels();
		$arPermBits = $this->get_arPermBits();
		$arPermLevels = array_flip($arPermLevels);
		if (!$id_level || !isset($arPermLevels[$id_level])) { $id_level = 1; }
		preg_match_all("/\d/", $arPermBits[$arPermLevels[$id_level]], $ar_p);
		$ar_p = $ar_p[0];
		for (; list($k, $v) = each($arAccessNames);)
		{
			$ar_p[$k] = isset($vars[$v]) ? $vars[$v] : $ar_p[$k];
		}
		return implode('', $ar_p);
	}
	/* */
	function have_perm($name, $level = '')
	{
		$ar_p = $this->get_arPermLevels();
		if ($level == '') { $level = $this->user_get('perm_level'); }
		for (;list($k, $v) = each($ar_p);)
		{
			if (($k == $name) && ($level >= $ar_p[$k]))
			{
				return true;
			}
		}
		return false;
	}
	/* */
	function url($url)
	{
		if (!$this->id_sess) { return $url; }
		$url = preg_replace("/[&?]+$/", "", $url);
		switch ($this->url_append_mode)
		{
			case 'get':
				$url .= ( (strpos($url, "?") != false) ?  "&" : "?" ) .
					urlencode($this->name) . '=' . $this->id_sess;
			break;
			default:
			break;
		}
		return $url;
	}
	/* Construct session unique number */
	function make_session_id()
	{
		$str_remote_ip = ($this->is_use_remote_ip) ? $this->remote_ip : '';
		$str_remote_ua = ($this->is_use_remote_ua) ? $this->remote_ua : '';
		return md5($this->url_login . $this->time_now . $str_remote_ip . $str_remote_ua . mt_rand() .$this->str_secret);
	}
	/* Garbage collector. Remove old sessions. */
	function gc()
	{
		global $oSqlQ, $oDb;
		if ((mt_rand()%100) < $this->gc_probability)
		{
			$sql = $oSqlQ->getQ('sess-purge', $this->time_now - $this->gc_time);
			$oDb->sqlExec($sql);
		}
	}
	/* Garbage collector. Remove not authorized sessions. */
	function gc_empty()
	{
		global $oSqlQ, $oDb;
		if ((mt_rand()%100) < ($this->gc_probability*2))
		{
			$sql = $oSqlQ->getQ('sess-purge-empty', $this->time_now - 600);
			$oDb->sqlExec($sql);
		}
	}
/* --------------------------------------------------------
 * Universal config reader/writer.
 *  2002-2004 Dmitry Shilnikov <dev at glossword dot info>
 * ------------------------------------------------------- */
	/**
	 *
	 * @globals $oDb, $oSqlQ
	 */
	function user_start($id_user)
	{
		global $oDb, $oSqlQ;
		if (!isset($oDb))
		{
			/* Start a new database class */
			$this->oDb = new $this->user_db_class;
		}
		else
		{
			/* Use an existend database class */
			$this->oDb =& $oDb;
			$this->oSqlQ =& $oSqlQ;
		}
		$this->id_user = $id_user;
		$this->user_load_values($this->id_user, 'merge');
	}
	/**
	 * Get settings. Autoloaded from start();
	 */
	function user_load_values($id_user, $mode = 'merge')
	{
		global $oDb, $oSqlQ;
		$sql_select = $this->user_db_field;
		if (!empty($this->user_db_plain) && is_array($this->user_db_plain))
		{
			$sql_select .= ', ' . implode(', ', $this->user_db_plain);
		}
		$arSql = $oDb->sqlExec($oSqlQ->getQ('get-user', $id_user));
#		prn_r( $arSql );
		$arSql = isset($arSql[0]) ? $arSql[0] : array();
		if (!empty($arSql))
		{
			$arSql2 = unserialize($arSql[$this->user_db_field]);
			unset($arSql[$this->user_db_field]);
			$arSql = array_merge($arSql, $arSql2);
		}
		if ($mode == 'merge')
		{
			$this->ar_user['settings'] = array_merge($this->ar_user['settings'], $arSql);
		}
		else
		{
			return $arSql;
		}
#		ksort($this->ar_user['settings']);
	}
	/**
	 * Adds a variable to user settings.
	 * @todo  overwrite or keep an existent variable
	 * @todo  add variables by array
	 */
	function user_set($varname, $value = '')
	{
		$this->is_changed = 1;
		$this->ar_user['settings'][$varname] = $value;
	}
	/**
	 * Gets user settings.
	 */
	function user_get($varname = '')
	{
		if ($varname == '')
		{
			return $this->ar_user['settings'];
		}
		else
		{
			for (reset($this->ar_user['settings']); list($k, $v) = each($this->ar_user['settings']);)
			{
				if ($k == $varname)
				{
					return $v;
				}
			}
		}
		return false;
	}
	/**
	 * Removes a variable from user settings.
	 */
	function user_unset($varname = '')
	{
		$this->is_changed = 1;
		if ($varname == '')
		{
			/* no variable defined, clean all custom variables */
			for (reset($this->user_db_plain); list($k, $v) = each($this->user_db_plain);)
			{
				$ar[$v] = $this->ar_user['settings'][$v];
			}
			$this->ar_user['settings'] = $ar;
		}
		else
		{
			/* remove a defined variable only */
			for (reset($this->ar_user['settings']); list($k, $v) = each($this->ar_user['settings']);)
			{
				if ($k == $varname)
				{
					unset($this->ar_user['settings'][$varname]);
				}
			}
		}
		return true;
	}
	/**
	 * Updates information, if changed.
	 */
	function _user_update()
	{
		/* prepare plain fields */
		for (reset($this->user_db_plain); list($k, $v) = each($this->user_db_plain);)
		{
			if (isset($this->ar_user['settings'][$v]))
			{
				/* prepare fields for SQL */
				$arSql[$v] = gw_text_sql($this->ar_user['settings'][$v]);
				/* exclude plain fields */
				unset($this->ar_user['settings'][$v]);
			}
		}
		/* filter blocked variable names */
		$user_db_plain = array('login','password','id_user','is_active','group');
		for (reset($user_db_plain); list($k, $v) = each($user_db_plain);)
		{
			if (isset($this->ar_user['settings'][$v]))
			{
				unset($this->ar_user['settings'][$v]);
			}
		}
		/* prepare encoded user settings */
		$arSql[$this->user_db_field] = gw_text_sql(serialize($this->ar_user['settings']) );
		for (reset($arSql); list($k, $v) = each($arSql);)
		{
			$arSqlV[] = $k ."='" . $v . "'";
		}
		$sql = sprintf('UPDATE %s SET %s WHERE %s = "%s"',
					$this->user_db_table,
					implode(', ', $arSqlV),
					$this->user_db_where,
					$this->id_user
				);
		if (isset($this->oDb))
		{
			$this->oDb->sqlExec($sql);
		}
	}
	function logout()
	{
		$this->user_close();
		/* Remove session */
		$sql = sprintf('DELETE FROM %s WHERE id_sess = "%s"',
					$this->sess_db_table,
					$this->id_sess
				);
		$this->oDb->sqlExec($sql);
		$this->error(3);
		
	}
	/**
	 * Finalize session and user setting, called at the end of script
	 */
	function user_close()
	{
		if ($this->is_changed)
		{
			$this->_user_update();
		}
		/* Update session time */
		$sql = sprintf('UPDATE %s SET changed = %d WHERE id_sess = "%s"',
					$this->sess_db_table,
					$this->time_now,
					$this->id_sess
				);
		if (isset($this->oDb))
		{
			$this->oDb->sqlExec($sql);
		}
	}
	/* */
	function get_htmlform($vars, $ar_req = array())
	{
	}
}
/* end of file */
?>