<?php

/* Change current directory to access for website files */
if (!chdir('..'))
{
    exit("Can't change directory to `..'");
}
define('IN_GW', TRUE);
error_reporting(E_ALL);
header('Content-Type: text/html; charset=utf-8');

/* Load configuration */
$sys['path_include'] = 'inc';
include_once('db_config.php');
$sys['is_prepend'] = 0;
include_once($sys['path_include'] . "/config.inc.php");

if (file_exists('gw_install/install_functions.php'))
{
	include_once('gw_install/install_functions.php');
}
else
{
	printf('<br/><b>Error:</b> File %s required.', '../gw_install/install_functions.php');
	exit;
}
include_once($sys['path_include']. '/constants.inc.php');

$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
$sys['html_title'] = 'Technical Support';

gw_html_open();

?>
<div style="text-align:left;background:#FFE;padding:0.5em;" class="xw">
<div style="float:right;padding:2px;" class="xq">Sponsored by (could be your company name)</div>
Technical support</div>

<div class="hr3"></div>

<div class="contents xu">

<p>
This page contains some important information on the (freeware)
distribution of Glossword, a software for making
online multilingual glossaries, dictionaries, encyclopedias.
</p>

<h3>This directory</h3>

<ul>
<li><p>Read license <a href="license_en.html">in English</a>, <a href="license_ru.html">in Russian</a></p></li>
<li><p><a href="../gw_install/install.php">Glossword setup wizard</a>
<br />(install 1.8.0, update from 1.6.x and 1.7.x, uninstall)</p></li>
<li><p><a href="check_string.php">Check for <tt>mbstring</tt> extension</a></p></li>
<li><p><a href="queries.txt">A few helpful SQL-queries for Glossword maintance</a></p></li>
<li><p><a href="tpl_variables.txt">The list of variables, used in HTML-templates</a></p></li>
<li><p><a href="allowed_tags.txt">The list of HTML-tags</a></p></li>
</ul>

<h3>Support</h3>

<p>If you have technical problems with
running, installing, or updating Glossword
write to <a href="mailto:dev@glossword.info?subject=support">dev@glossword.info</a>
and include the following information:</p>


<ol>
<li>Contact name.</li>
<li>Your City, Country.</li>
<li>Problem summary.</li>
<li>Current results.</li>
<li>Expected results.</li>
<li>How to reproduce the problem.</li>
<li>System information of server where Glossword installed
<br />
(<a href="sys_info.php">Get system information of this server</a>).</li>
</ol>

<p>
When you need just an advice feel free to write to <a href="mailto:dev@glossword.info?subject=Glossword%20support">dev@glossword.info</a> also.
Additional e-mail is <a href="mailto:tty01@rambler.ru?subject=Glossword%20support">tty01@rambler.ru</a>.
</p>

<p>
If you need a hosting for your Glossword installation, try (could be your company name).
</p>

<h3>Help Glossword</h3>

<p>Glossword is freeware, but it needs your financial support in order to be the modern
dictionary management software. Your donation will go to help the developer
keep up the Glossword growth. Author needs in regular payments
for internet access, rental fees, clothes, and food.</p>

<p>Donators have higher priority for support and receive quicker resolution
for any issues related to Glossword usage.</p>

<p><b>How to donate</b></p>
<ul>
<li><p>Use <a href="https://www.moneybookers.com/app/?rid=289405">MoneyBookers.com</a> online payment system. Send money using MoneyBookers interface to dev@glossword.info.</p></li>
<li><p>As PayPal does not operate in Russian Federation, use Western Union.
To send money <a href="http://www.westernunion.com/info/agentLocatorLookup.asp">find the nearest Western Union department</a> located in your city.
In the application form please specify:
Your name, Your city, Country, Money Transfer Control Number (MTCN).</p>
Receiver:
<div style="font-family:monospace">
<br />First name: Nick Vladimirovich
<br />Last name: Shilnikov
<br />Address: Moscow, Russia
</div>
</li>
</ul>
<p>Using donation you may order specific options for your Glossword installation
like "copyright removal" and more components like FAQ manager, Links catalog,
Mailing list, News feed. Please contact for more details.</p>

<h3>After installation</h3>

<p>Several tips, you need to know before to start tuning and customizing the software.</p>


<p><b>Search-friendly URLs</b></p>

To enable Apache`s module <tt>‘mod_rewrite’</tt>:

<ol>
<li>Edit file <tt>‘/glossword/inc/config.inc.php’</tt>:
<div class="codetitle">glossword/inc/config.inc.php or glossword/custom_vars.php</div>
<ol class="code">
<li>$sys['is_mod_rewrite'] = 1; /* [ 0 - off | 1 - on ] */</li>
</ol>

</li>
<li>Edit file <tt>‘/glossword/.htaccess’</tt>:

<div class="codetitle">glossword/.htaccess</div>
<ol class="code">
<li>## mod_rewrite configuration</li>
<li>RewriteEngine on</li>
<li>RewriteBase /glossword</li>
<li>RewriteRule ([0-9a-zA-Z-.,_])+xhtml$ index.php</li>
</ol>

</li>
</ol>




<p><b>Cache directory</b></p>

<p>Database caching is used to speed up website.
When enabled, some pages displayed as fast as static HTML.
It takes about 50 Kbytes on disk, + 1..30 Kbytes per dictionary (uncompressed).
To enable, open <tt>‘glossword/inc/config.inc.php’</tt>,
search for section ‘‘System settings’’ and set <tt>$sys['is_cache']</tt> to <tt>1</tt>:
</p>

<div class="codetitle">glossword/inc/config.inc.php</div>
<ol class="code">
<li>$sys['is_cache_sql']    = 1;</li>
<li>$sys['cache_zlib']      = 0;</li>
<li>$sys['cache_lifetime']  = 10080; /* week */</li>
<li>$sys['path_cache_sql']  = 'gw_temp/cache_sql';</li>
</ol>

<p>In addition, you can enable or disable Zlib compression for cache files
and change directory name. Make sure cache directory is writable by server.
Zlib compression allows to save extra space but takes a little more CPU.</p>

<p><b>Page caching</b></p>

<p>Besides caching database results, Glossword allows to turn on HTTP-caching.
It is when a page contents will be loaded from browser`s cache on every repeated
page request instead of being transfered from the server to user.</p>

<div class="codetitle">glossword/inc/config.inc.php</div>
<ol class="code">
<li>$sys['is_cache_http']   = 1; /* [ 0 - off | 1 - on ] */</li>
</ol>

<p><b>Post-processing functions</b></p>

<p>The text of definitions and all HTML-code is parsed by special PHP-functions
for transformation before to output.</p>

<div class="codetitle">glossword/inc/config.inc.php</div>
<ol class="code">
<li>$sys['filters_output']    = array('gw_text_smooth');</li>
<li>$sys['filters_defn']      = array('gw_text_smooth_defn');</li>
<li>$sys['is_debug_output']   = 0; /* [ 0 - off | 1 - on ] */</li>
</ol>

<p>You may declare your own PHP-function inside file <tt>‘glossword/custom_vars.php’</tt>
and then just to add the function name to configuration:</p>
<div class="codetitle">glossword/inc/config.inc.php or glossword/custom_vars.php</div>
<ol class="code">
<li>$sys['filters_defn'] = array('gw_text_smooth_defn', 'gw_autolinks');</li>
</ol>

<p>Extension "Autolinks", which is included into package by default, works in the same way.
By changing value of <tt>$sys['is_debug_output']</tt> it is possible to activate
or deactivate all post-processing functions.</p>

<h3>Dictionary examples</h3>

<p>Example Glossword dictionary. Used more than 40 languages.</p>
<ul>
<li><a href="d_example.xml">d_example.xml</a></li>
</ul>

<p>Log in, create dictionary, import <tt>XML</tt>-file.</p>

<h3>Additional information</h3>

<ul>
<li><a href="http://glossword.info/dev_part/docs/index.xhtml">Glossword 1.x documentation</a></li>
<li><a href="http://sourceforge.net/projects/glossword/">Glossword at SourceForge.net</a></li>
<li><a href="http://freshmeat.net/projects/glossword/">Glossword at FreshMeat.net</a></li>
</ul>

<hr/>
<p>
You may remove <tt>‘/glossword/support’</tt> directory from this server.
</p>


<hr />

<p><a href="..">Back to local installation</a></p>
<p>&#169; 2002-2006 <a href="mailto:dev@glossword.info">Dmitry N. Shilnikov</a>, Glossword developer</p>
</div>

</div>

</body>
</html>